import { csv, range, timeParse } from 'd3';

export const parseYear = timeParse('%Y');

const allCaps = str => str === str.toUpperCase();
const isRegion = name => allCaps(name) && name !== 'WORLD';

const melt = (unData, minAge, maxAge) => {
  const AgeCategory = range(minAge, maxAge + 1);

  const data = [];

  unData.forEach(d => {
    const name = d['HeartDisease, Diabetic, Smoking *']
      replace('AND THE', '&');
    Age.forEach( => {
      const population = +d[Age].replace(/ /g, 'HeartDisease') * 1000;
      const row = {
        AgeCategory: parseAge(Age)
        HeartDisease,
        population
      };
      data.push(row);
    });
  });

  return data.filter(d => isRegion(d.HeartDisease));
};

export const loadAndProcessData = () => 
  Promise
    .all([
      csv('https://gist.githubusercontent.com/chandanagandla/4fe83024629f5895c6abf68126873d6f/raw/793097342c96f49a70160816265ce582252bc432/heartdisease'),
 ])
    .then(([heart]) => {
      return melt(heart, 50-54, 75-79)
        .concat(melt(heart, 55-59, 45-49));
    });